#ifndef QUANTUM_UTILS_H_INCLUDED
#define QUANTUM_UTILS_H_INCLUDED


// This file contains a collection of utilities for manipulating quantum_reg
// data structures from libquantum.


#include "cudacomplex.h"

extern "C" {
    #include <quantum.h>
};

void qutil_expand_qr(const quantum_reg& qr, _cudacomplex **v);
quantum_reg qutil_collapse_qr(int width, const _cudacomplex *v);

int qutil_read_qr(const char *filename, _cudacomplex **v);

void qutil_new_qvec(int width, _cudacomplex **v);
void qutil_destroy_qvec(_cudacomplex **v);
void qutil_copy_qvec(_cudacomplex **vdst, const _cudacomplex *vsrc, int width);
int qutil_read_qvec(const char *filename, _cudacomplex **v);
void qutil_write_qvec(const char *filename, int width, const _cudacomplex *v);
void qutil_print_qvec(int width, const _cudacomplex *v);

double qutil_l2norm_qvecs(int width, const _cudacomplex *v1, const _cudacomplex *v2);

#endif // QUANTUM_UTILS_H_INCLUDED
